;------------------
DrawLocation
;attributes
	LD HL,22528+128
	 LD B,192
	CALL AttrBlock
	 LD B,64
	CALL AttrBlock
	 LD B,128
	CALL AttrBlock
	LD BC,255
	CALL AttrBlock
	LD (HL),A

;graphics	

	LD HL,16384+512+14		;sign
	LD DE,Sign
	LD BC,4*256+16
	CALL DrawXor
	
	LD B,32				;sky lines
	LD HL,18432
DrawLocation2
	PUSH HL
	PUSH BC
	LD DE,Sky
	LD BC,1*256+16
	CALL DrawXor
	POP BC
	POP HL
	INC L
	DJNZ DrawLocation2
	
	LD B,8				;hills
	LD HL,18432+4*256+96
DrawLocation3
	PUSH HL
	PUSH BC
	LD DE,Hills
	LD BC,4*256+12
	CALL DrawXor
	POP BC
	POP HL
	INC L
	INC L
	INC L
	INC L
	DJNZ DrawLocation3
	
	LD BC,32*256+255		;road side
	LD HL,18432+7*256+224
DrawLocation4
	LD (HL),C
	INC L
	DJNZ DrawLocation4
	
	LD HL,16384+100			;draw distance bar
	LD BC,24*256+5
	LD D,B
	LD E,255

DrawLocation5
	PUSH HL
DrawLocation6	
	LD	(HL),E				;one pixel line
	INC L
	DJNZ DrawLocation6
	POP HL
	CALL OnePixelLineDown	;next pixel line
	LD B,D					;restore distance bar width
	DEC C
	JR NZ,DrawLocation5
	
	RET
	
;------------------
AttrBlock
;paint attribute block (HL-left upper corner, C-attribute, B-number of chars)
;the block is 32 chars wide
	LD A,(DE)		;get attribute
	INC DE			;new attribute for next block
AttrBlock2
	LD (HL),A
	INC HL
	DJNZ AttrBlock2
	RET
	

;------------------
DrawXor
;draw sprite 16 pixel lines, 4 bytes wide
;DE-source, HL-address, B-width in bytes, C- height in pixel lines
	
DrawXor2
	PUSH BC
	PUSH HL
	
DrawXor3
	LD A,(DE)								;XOR source data with screen content
	XOR (HL)
	LD (HL),A
	INC DE
	INC L
	DJNZ DrawXor3						;one line of pixels - 4 bytes
	
	POP HL
	POP BC
	CALL OnePixelLineDown
	DEC C
	JR NZ,DrawXor2
	RET
	
;-----
OnePixelLineDown
;requires HL as screen address
	INC H ;go to new line
	LD A,H
	AND 00000111B
	OR A ;h=0 -> going to new character line
	RET NZ; new line belongs to the same character line
	
	LD A,L ;going to new character line
	ADD A,32
	LD L,A
	RET C;going to new screen segment, if e.g h was 71, now it is 72
	
	LD A,H
	SUB 8
	LD H,A; decrease h if we are in the same screen segment
	RET
	
;----------------	
XYtoHL
;turn XY into HL screen coordinates
;D contains X, E contains Y 
;doesn't destroy DE
 
	LD  A,E
	AND  00000111b
	LD  H,A
 	LD  A,E
 	RRA 
 	RRA 
 	RRA 
 	AND  00011000b
 	OR  H
 	OR  01000000b
 	LD  H,A					;H found
 
 	LD  A,D
 	RRA 
 	RRA 
 	RRA 
 	AND  00011111b
 	LD  L,A
 	LD  A,E
 	RLA 
 	RLA 
 	AND  11100000b
 	OR  L
 	LD  L,A					;L found
 	
 	LD A,D
 	AND 00000111b			;shift found
  	RET
	

;------------------
MoveBackgroundLeft
;shift background one pixel left
	LD HL,18432+96+31		;shifted block right upper corner
	LD B,15					;number of lines
	
MoveBackgroundLeft2
	PUSH HL					

	LD C,L					;store position
	LD A,L
	SUB 31
	LD L,A					;go to most left byte
	LD A,(HL)
	RLA 					;rotate most left byte, not is screen but virtually
							;to sets carry flag appropriately (to be used by most right byte_	
	LD L,C					;back to right side
	
;rotate one pixel line
	RL (HL)					
	DEC L
	RL (HL)
	DEC L	
	RL (HL)
	DEC L	
	RL (HL)
	DEC L
	RL (HL)
	DEC L		
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L	
	RL (HL)
	DEC L		
	RL (HL)
	DEC L	;10
		
	RL (HL)
	DEC L	
	RL (HL)
	DEC L	
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L ;20
		
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)
	DEC L
	RL (HL)

	POP HL
	CALL OnePixelLineDown		;next line
	DJNZ MoveBackgroundLeft2
	RET	
	
;-----------
ClearScreen
	XOR A
	LD (23624),A 
	OUT (254),A
	LD A,66
	LD (23693),A			;Basic system variable
	CALL 3435				;Rom CLS
	RET	
	
	
;------------------
Truck:
	.BYTE	255,254,240,  0,140,102,248,  0
	.BYTE	148,170,204,  0,140,102,198,  0
	.BYTE	148,170,194,  0,140,102,195,  0
	.BYTE	148,170,255,  0,255,254,255,  0
	.BYTE	  0,  0,255,  0,255,254,255,  0
	.BYTE	227,254,199,  0,221,254,187,  0
	.BYTE	 58,  0,116,  0, 62,  0,124,  0
	.BYTE	 54,  0,108,  0, 28,  0, 56,  0
	
Hills:
	.BYTE	  0,  0, 56,  0,  0,  0,254,  0
	.BYTE	  0,  7,255,128,  0, 31,255,252
	.BYTE	255,255, 85,255,255,250,170,255
	.BYTE	255,212,  1, 95,250,168,  0,171
	.BYTE	 85, 64,  0, 21,170,  0,  0,  2
	.BYTE	 80,  0,  0,  0,  0,  0,  0,  0

Sky:
	.BYTE	255,  0,  0,  0,  0,255,  0,  0
	.BYTE	255,  0,255,  0,255,255,  0,255
	
Mine
	.BYTE 60,0,86,0,171,0	
	
Go
	.BYTE	113,198,203, 38,195, 38,219, 38
	.BYTE	203, 32,113,198
End
	.BYTE	246, 92,199, 90,231,218,198,218
	.BYTE	246, 92
	
Sign:
	.BYTE	127,255,255,254,128,  0,  0,  1
	.BYTE	185,140,103, 37,181,154,214,165
	.BYTE	185,154,214,153,181,154,214,153
	.BYTE	185,204,103, 25,128,  0,  0,  1
	.BYTE	158,102, 92,241,152,215, 90,193
	.BYTE	158,247,218,241,130,214,218, 17
	.BYTE	158,214, 92,241,192,  0,  0,  3
	.BYTE	224,  0,  0,  7,255,255,255,255  

;--------------	
Level1Colors
	.BYTE 47,56,16,112
Level2Colors
	.BYTE 11,24,72,40
Level3Colors
	.BYTE 22,48,112,48
Level4Colors
	.BYTE 1,8,104,40
