;----------------------
DrawMinesXor
;draw 6 mines
	LD HL,MineTable
	LD B,6					;nr of mines
	
DrawMinesXor2
	PUSH BC
	INC HL					;skip mine Y		
	INC HL					;skip mine X
	
	LD E,(HL)
	INC HL
	LD D,(HL)				;mine HL into DE
	INC HL					;go to mine shift
	LD A,(HL)				;mine shift into A
	
	PUSH HL	
	CALL DrawMineXor
	POP HL					;restore mine table pointer
	
	POP BC					;restore nr of mines left to do
	INC HL					;go to next mine data
	DJNZ DrawMinesXor2
	RET
	
;---------
;draw one mine	
	
DrawMineXor
;find mine shifted frame
	PUSH DE					;store mine HL position
	
	LD HL,35512				;start of shift frames
	LD DE,6
	OR A					;A contains mine shift
	JR Z,DrawMineXor3		;shift 0
DrawMineXor2
	ADD HL,DE				;find proper frame
	DEC A
	JR NZ,DrawMineXor2
	
DrawMineXor3
	EX HL,DE				;frame into DE
	POP HL					;restore mine position
	LD BC,2*256+3
	CALL DrawXor
	RET
	
;--------------
MoveMines

	LD HL,MineTable
	LD B,6

MoveMines2
;move one mine	
	LD E,(HL)				;read mine XY
	INC HL
	LD D,(HL)
	DEC D					;mine goes left
	LD (HL),D				;write it to mine data
	
	LD A,D
	OR A					;A=0 -> mine reaches edge -> create new mine
	JR NZ,MoveMines3

;create new mine
	LD A,248
	LD (HL),A				;new X- right edge
	DEC HL
		
	LD A,R					;new Y- random
	AND 63					;A=0-63
	LD C,A
	LD A,128
	ADD A,C
	CP 187					;mine Y must be less than 18
	JR C,MoveMines21	
	LD A,187				;if it is bigger, adjust it
	
MoveMines21	
	LD (HL),A				;write new Y
	INC HL
	
MoveMines3
	PUSH HL
	CALL XYtoHL				;screen position of the mine
	EX DE,HL				;put it into DE
	POP HL					;restore mine data pointer
	
	INC HL
	LD (HL),E
	INC HL
	LD (HL),D				;write mine HL position
	INC HL
	LD (HL),A				;write shift
	INC HL					;go to next mine
	
	DJNZ MoveMines2
	RET