;------------------------------
DrawTruckXor
	CALL FindTruckFrame		;find truck shifted frame  

	LD HL,(TruckPosHL)
	LD BC,4*256+16
	CALL DrawXor
	RET
	
;----------
FindTruckFrame	
	LD HL,35000				;start of shifted frames
	LD DE,64
	LD A,(TruckShift)
	OR A
	JR Z,FindTruckFrame3	;shift 0
FindTruckFrame2
	ADD HL,DE				;find proper frame
	DEC A
	JR NZ,FindTruckFrame2
FindTruckFrame3
	EX HL,DE				;frame into DE
	RET

;------------------
MoveTruck
	LD DE,(TruckPosXY)
	LD BC,#EFFE				;input - Sinclair joystick
	IN A,(C)

;go up	
	BIT 1,A					;test input
	JR NZ,MoveTruck2		;no going up
	DEC E					;going up - change position
	
	
;go right	
MoveTruck2
	BIT 2,A
	JR NZ,MoveTruck3		
	INC E					
	
;go left	
MoveTruck3
	BIT 4,A
	JR NZ,MoveTruck4		
	DEC D					

;go right
MoveTruck4
	BIT 3,A
	JR NZ,MoveTruck5		
	INC D
	
;write new position	
MoveTruck5
;check edges of movement
	LD A,D
	CP 255
	JR NZ,MoveTruck51	
	INC D				;left edge
	
MoveTruck51	
	CP 113
	JR NZ,MoveTruck52
	DEC D				;right edge	

MoveTruck52	
	LD A,E
	CP 127
	JR NZ,MoveTruck53
	INC E				;top edge	
	
MoveTruck53	
	CP 177
	JR NZ,MoveTruck54
	DEC E				;bottom edge	
	
		
MoveTruck54		
	CALL XYtoHL
	LD (TruckPosHL),HL
	LD (TruckPosXY),DE
	LD (TruckShift),A
	RET

	
;-------------------		
CheckCollision
	CALL FindTruckFrame	;address of current truck sprite into DE	
	LD HL,(TruckPosHL)	;screen truck position 
	
	LD BC,4*256+16		;size - width+height

CheckCollision2
	PUSH HL
	PUSH BC

;check one pixel line	
CheckCollision3
	LD A,(DE)				;draw virtually truck once again over already drawn trcuk
	OR (HL)					;but this time we use OR method, not XOR
	CP (HL)					;if the methods give different result -> truck graphics  overlap with mine graphics=collision
	JR NZ,CheckCollision4	;no zero- collision detected
	
	INC HL					;go to next byte of data
	INC DE
	DJNZ CheckCollision3
	
	POP BC
	POP HL
	CALL OnePixelLineDown	;go to next line on the screen
	DEC C
	JR NZ,CheckCollision2	;repeat until 16 lines are done
	RET
	
CheckCollision4	
;explosion effect
	LD D,40
CheckCollision5	
	HALT
	LD BC,3000
CheckCollision6
	LD A,2
	OUT (254),A
	DEC BC
	NOP
	LD A,16
	OUT (254),A
	LD A,B
	OR C
	JR NZ,CheckCollision6
	
	DEC D
	JR NZ, CheckCollision5	
	
	

	JP GameOver